#ifndef _TBakeTexture_H_
#define _TBakeTexture_H_

enum
{
	ID_TEXTURESETTINGS        = 1002,
	ID_BAKEOPTIONS            = 1003,
	ID_COLORGROUP             = 1004,
	ID_LUMINANCEGROUP         = 1005,
	ID_DETAILSGROUP           = 1009,
	ID_ILLUMINATIONGROUP      = 1006,
	ID_NORMALGROUP            = 1007,
	ID_OPTIMAL_MAPPING        = 1008,
	ID_AOGROUP                = 1010, 

	BAKETEXTURE_NAME					= 2000, // filename
	BAKETEXTURE_SINGLEFILE    = 2001, // bool
	BAKETEXTURE_FORMAT        = 2002, // long (FILTER_*)
	BAKETEXTURE_WIDTH         = 2003, // long
	BAKETEXTURE_HEIGHT        = 2004, // long
	BAKETEXTURE_BACKGROUND    = 2005, // color
	BAKETEXTURE_SUPERSAMPLING = 2006, // long
	BAKETEXTURE_PIXELBORDER   = 2007, // long
	BAKETEXTURE_CONTINUE_UV   = 2025, // bool
	BAKETEXTURE_USE_POLYSELECTION = 2008, // bool
	BAKETEXTURE_COLOR_DEPTH   = 2009, // long
	BAKETEXTURE_OPTIONS_BTN   = 2010, // button
	BAKETEXTURE_OPTIONS       = 2011, // BaseContainer
	BAKETEXTURE_FPS           = 2012, // long
	BAKETEXTURE_USE_CURRENT   = 2013, // bool
	BAKETEXTURE_TIME_MIN      = 2014, // time
	BAKETEXTURE_TIME_MAX      = 2015, // time
	BAKETEXTURE_NAME_FORMAT   = 2016, // long
		BAKETEXTURE_NAME0000_TIF = 1,
		BAKETEXTURE_NAME0000     = 2,
		BAKETEXTURE_NAME_0000    = 3,
		BAKETEXTURE_NAME000_TIF  = 4,
		BAKETEXTURE_NAME000      = 5,
		BAKETEXTURE_NAME_000     = 6,
		BAKETEXTURE_NAME_0000_TIF = 7,
	BAKETEXTURE_USE_BUMP      = 2017, // bool
	BAKETEXTURE_USE_CAMERA_VECTOR = 2018, // bool

	BAKETEXTURE_AUTOSIZE      = 2019, // bool
	BAKETEXTURE_AUTO_MIN      = 2020, // long
	BAKETEXTURE_AUTO_MAX      = 2021, // long
	BAKETEXTURE_AUTO_PIXEL_SIZE = 2022, // real

	BAKETEXTURE_WIDTH_AUTO    = 2023, // long (read only)
	BAKETEXTURE_HEIGHT_AUTO   = 2024, // long (read only)

	BAKETEXTURE_CHANNEL_AO    = 2100, // bool
	BAKETEXTURE_CHANNEL_NORMAL = 2101, // bool
	BAKETEXTURE_CHANNEL_S_COLOR = 2102, // bool
	BAKETEXTURE_CHANNEL_COLOR = 2103, // bool
	BAKETEXTURE_CHANNEL_LUMINANCE = 2104, // bool
	BAKETEXTURE_CHANNEL_DIFFUSION = 2105, // bool
	BAKETEXTURE_CHANNEL_BUMP  = 2106, // bool
	BAKETEXTURE_CHANNEL_ALPHA = 2107, // bool
	BAKETEXTURE_CHANNEL_TRANS = 2108, // bool
	BAKETEXTURE_CHANNEL_ILLUMINATION = 2109, // bool
	BAKETEXTURE_CHANNEL_UVMAP = 2110, // bool
	BAKETEXTURE_CHANNEL_SHADOWS = 2111, // bool
	BAKETEXTURE_CHANNEL_REFLECTION = 2112, // bool

	BAKETEXTURE_PREVIEW       = 2200, // preview

	BAKETEXTURE_TAGLIST       = 2300, // in/exclude

	BAKETEXTURE_COLOR_ILLUM   = 2400, // bool
	BAKETEXTURE_COLOR_SHADOWS = 2401, // bool
	BAKETEXTURE_COLOR_LUMINANCE = 2402, // bool
	BAKETEXTURE_COLOR_DIFFUSION = 2403, // bool

	BAKETEXTURE_LUMINANCE_DIFFUSION = 2410, // bool

	BAKETEXTURE_ILLUMINATION_SHADOWS = 2120, // bool

	BAKETEXTURE_NORMAL_METHOD = 2420, // long
		BAKETEXTURE_NORMAL_METHOD_OBJECT = 1,
		BAKETEXTURE_NORMAL_METHOD_TANGENT = 2,
		BAKETEXTURE_NORMAL_METHOD_WORLD = 3,
	BAKETEXTURE_NORMAL_FLIP_X = 2421,
	BAKETEXTURE_NORMAL_FLIP_Y = 2422,
	BAKETEXTURE_NORMAL_FLIP_Z = 2423,
	BAKETEXTURE_NORMAL_SWAP_YZ = 2424,

	BAKETEXTURE_AO_TO_VERTEX  = 2430, // bool
	BAKETEXTURE_AO_SELFINTERSECTION = 2431, // bool

	BAKETEXTURE_MAPPING       = 2500, // long
		BAKETEXTURE_MAPPING_OFF = 0,
		BAKETEXTURE_MAPPING_CUBIC = 1,
		BAKETEXTURE_MAPPING_ANGLE = 2,
	BAKETEXTURE_RELAXCOUNT    = 2507, // long

	BAKETEXTURE_BAKE          = 9996, // button
	BAKETEXTURE_STOP          = 9997, // button
	BAKETEXTURE_DELETE        = 9998, // button
	BAKETEXTURE_BAKE_PREVIEW  = 9999, // button

	BAKETEXTURE_DUMMY
};

#endif // TBakeTexture

